# 指定CMake最低版本
cmake_minimum_required(VERSION 3.5)
# 定义项目名称
project(example_topic)

# 默认使用C++14标准
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

# 如果使用的是GNU C++编译器或Clang，添加编译选项
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

# 查找依赖项
find_package(ament_cmake REQUIRED)
find_package(rclcpp REQUIRED)
find_package(std_msgs REQUIRED)

# 添加可执行文件
add_executable(pub_node src/pub_node.cpp)
add_executable(sub_node src/sub_node.cpp)

# 为目标添加依赖项
ament_target_dependencies(pub_node rclcpp std_msgs)
ament_target_dependencies(sub_node rclcpp std_msgs)

# 安装目标
install(TARGETS
  pub_node
  sub_node
  DESTINATION lib/${PROJECT_NAME}
)

# 包含目录
include_directories(include)

# 安装头文件
install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION include/${PROJECT_NAME}/
)

# 安装脚本
install(DIRECTORY launch
  DESTINATION share/${PROJECT_NAME}/
)

# 安装配置文件
install(DIRECTORY config
  DESTINATION share/${PROJECT_NAME}/
)

# 包含ament_package()宏
ament_package()

